gi-gio-2.0.27: Gio bindings

Copyright | Will Thompson Iñaki García Etxebarria and Jonas Platte
License | LGPL-2.1
Maintainer | Iñaki García Etxebarria
Safe Haskell | None
Language | Haskell2010

GI.Gio.Objects.ApplicationCommandLine

Contents

- Exported types
- Methods
  - Overloaded methods
  - createFileForArg
  - getArguments
  - getCwd
  - getEnviron
  - getExitStatus
  - getIsRemote
  - getOptionsDict
  - getPlatformData
  - getStdin
  - getenv
  - setExitStatus
- Properties
  - arguments
  - isRemote
  - options
  - platformData

Description

`ApplicationCommandLine` represents a command-line invocation of an application. It is created by `Application` and emitted in the commandLine signal and virtual function.

The class contains the list of arguments that the program was invoked with. It is also possible to query if the commandline invocation was local (ie: the current process is running in direct response to the invocation) or remote (ie: some other process forwarded the commandline to this process).

The GApplicationCommandLine object can provide the `argc` and `argv` parameters for use with the `OptionContext` command-line parsing API, with the `applicationCommandLineGetArguments` function. See [gapplication-example-cmdline3.c][gapplication-example-cmdline3] for an example.

The exit status of the originally-invoked process may be set and messages can be printed to stdout or stderr of that process. The lifecycle of the originally-invoked process is tied to the lifecycle of this object (ie: the process exits when the last reference is dropped).

The main use for `ApplicationCommandLine` (and the commandLine signal) is 'Emacs server' like use cases: You can set the `EDITOR` environment variable to have e.g. git use your favourite editor to edit commit messages, and if you already have an instance of the editor running, the editing will happen in the running instance, instead of opening a new one. An important aspect of this use case is that the process that gets started by git does not return until the editing is done.

Normally, the commandline is completely handled in the commandLine handler. The launching instance exits once the signal handler in the primary instance has returned, and the return value of the signal handler becomes the exit status of the launching instance.

### C code

    static int
    command_line (GApplication            *application,
                  GApplicationCommandLine *cmdline)
    {
      gchar **argv;
      gint argc;
      gint i;

      argv = g_application_command_line_get_arguments (cmdline, &argc);

      g_application_command_line_print (cmdline,
                                        "This text is written back\n"
                                        "to stdout of the caller\n");

      for (i = 0; i < argc; i++)
        g_print ("argument %d: %s\n", i, argv[i]);

      g_strfreev (argv);

      return 0;
    }

The complete example can be found here: gapplication-example-cmdline.c

In more complicated cases, the handling of the comandline can be split between the launcher and the primary instance.

### C code

    static gboolean
     test_local_cmdline (GApplication   *application,
                         gchar        ***arguments,
                         gint           *exit_status)
    {
      gint i, j;
      gchar **argv;

      argv = *arguments;

      i = 1;
      while (argv[i])
        {
          if (g_str_has_prefix (argv[i], "--local-"))
            {
              g_print ("handling argument %s locally\n", argv[i]);
              g_free (argv[i]);
              for (j = i; argv[j]; j++)
                argv[j] = argv[j + 1];
            }
          else
            {
              g_print ("not handling argument %s locally\n", argv[i]);
              i++;
            }
        }

      *exit_status = 0;

      return FALSE;
    }

    static void
    test_application_class_init (TestApplicationClass *class)
    {
      G_APPLICATION_CLASS (class)->local_command_line = test_local_cmdline;

      ...
    }

In this example of split commandline handling, options that start with `--local-` are handled locally, all other options are passed to the commandLine handler which runs in the primary instance.

The complete example can be found here: gapplication-example-cmdline2.c

If handling the commandline requires a lot of work, it may be better to defer it.

### C code

    static gboolean
    my_cmdline_handler (gpointer data)
    {
      GApplicationCommandLine *cmdline = data;

      // do the heavy lifting in an idle

      g_application_command_line_set_exit_status (cmdline, 0);
      g_object_unref (cmdline); // this releases the application

      return G_SOURCE_REMOVE;
    }

    static int
    command_line (GApplication            *application,
                  GApplicationCommandLine *cmdline)
    {
      // keep the application running until we are done with this commandline
      g_application_hold (application);

      g_object_set_data_full (G_OBJECT (cmdline),
                              "application", application,
                              (GDestroyNotify)g_application_release);

      g_object_ref (cmdline);
      g_idle_add (my_cmdline_handler, cmdline);

      return 0;
    }

In this example the commandline is not completely handled before the commandLine handler returns. Instead, we keep a reference to the `ApplicationCommandLine` object and handle it later (in this example, in an idle). Note that it is necessary to hold the application until you are done with the commandline.

The complete example can be found here: gapplication-example-cmdline3.c

Synopsis

- newtype ApplicationCommandLine = ApplicationCommandLine (ManagedPtr ApplicationCommandLine)
- class (GObject o, IsDescendantOf ApplicationCommandLine o) => IsApplicationCommandLine o
- toApplicationCommandLine :: (MonadIO m, IsApplicationCommandLine o) => o -> m ApplicationCommandLine
- applicationCommandLineCreateFileForArg :: (HasCallStack, MonadIO m, IsApplicationCommandLine a) => a -> [Char] -> m File
- applicationCommandLineGetArguments :: (HasCallStack, MonadIO m, IsApplicationCommandLine a) => a -> m [[Char]]
- applicationCommandLineGetCwd :: (HasCallStack, MonadIO m, IsApplicationCommandLine a) => a -> m (Maybe [Char])
- applicationCommandLineGetEnviron :: (HasCallStack, MonadIO m, IsApplicationCommandLine a) => a -> m [[Char]]
- applicationCommandLineGetExitStatus :: (HasCallStack, MonadIO m, IsApplicationCommandLine a) => a -> m Int32
- applicationCommandLineGetIsRemote :: (HasCallStack, MonadIO m, IsApplicationCommandLine a) => a -> m Bool
- applicationCommandLineGetOptionsDict :: (HasCallStack, MonadIO m, IsApplicationCommandLine a) => a -> m VariantDict
- applicationCommandLineGetPlatformData :: (HasCallStack, MonadIO m, IsApplicationCommandLine a) => a -> m (Maybe GVariant)
- applicationCommandLineGetStdin :: (HasCallStack, MonadIO m, IsApplicationCommandLine a) => a -> m InputStream
- applicationCommandLineGetenv :: (HasCallStack, MonadIO m, IsApplicationCommandLine a) => a -> [Char] -> m Text
- applicationCommandLineSetExitStatus :: (HasCallStack, MonadIO m, IsApplicationCommandLine a) => a -> Int32 -> m ()
- constructApplicationCommandLineArguments :: (IsApplicationCommandLine o, MonadIO m) => GVariant -> m (GValueConstruct o)
- getApplicationCommandLineIsRemote :: (MonadIO m, IsApplicationCommandLine o) => o -> m Bool
- constructApplicationCommandLineOptions :: (IsApplicationCommandLine o, MonadIO m) => GVariant -> m (GValueConstruct o)
- constructApplicationCommandLinePlatformData :: (IsApplicationCommandLine o, MonadIO m) => GVariant -> m (GValueConstruct o)

# Exported types

newtype ApplicationCommandLine Source #

Memory-managed wrapper type.

Constructors

ApplicationCommandLine (ManagedPtr ApplicationCommandLine) |

#### Instances

Instances details

Eq ApplicationCommandLine Source # |
Instance details Defined in GI.Gio.Objects.ApplicationCommandLine Methods (==) :: ApplicationCommandLine -> ApplicationCommandLine -> Bool # (/=) :: ApplicationCommandLine -> ApplicationCommandLine -> Bool #
GObject ApplicationCommandLine Source # |
Instance details Defined in GI.Gio.Objects.ApplicationCommandLine
TypedObject ApplicationCommandLine Source # |
Instance details Defined in GI.Gio.Objects.ApplicationCommandLine Methods glibType :: IO GType Source #
ManagedPtrNewtype ApplicationCommandLine Source # |
Instance details Defined in GI.Gio.Objects.ApplicationCommandLine Methods toManagedPtr :: ApplicationCommandLine -> ManagedPtr ApplicationCommandLine Source #
IsGValue ApplicationCommandLine Source # | Convert `ApplicationCommandLine` to and from `GValue` with `toGValue` and `fromGValue`.
Instance details Defined in GI.Gio.Objects.ApplicationCommandLine Methods toGValue :: ApplicationCommandLine -> IO GValue Source # fromGValue :: GValue -> IO ApplicationCommandLine Source #
HasParentTypes ApplicationCommandLine Source # |
Instance details Defined in GI.Gio.Objects.ApplicationCommandLine
type ParentTypes ApplicationCommandLine Source # |
Instance details Defined in GI.Gio.Objects.ApplicationCommandLine type ParentTypes ApplicationCommandLine = '[Object]

class (GObject o, IsDescendantOf ApplicationCommandLine o) => IsApplicationCommandLine o Source #

Type class for types which can be safely cast to `ApplicationCommandLine`, for instance with `toApplicationCommandLine`.

#### Instances

Instances details

(GObject o, IsDescendantOf ApplicationCommandLine o) => IsApplicationCommandLine o Source # |
Instance details Defined in GI.Gio.Objects.ApplicationCommandLine

toApplicationCommandLine :: (MonadIO m, IsApplicationCommandLine o) => o -> m ApplicationCommandLine Source #

Cast to `ApplicationCommandLine`, for types for which this is known to be safe. For general casts, use `castTo`.

# Methods

## Overloaded methods

## createFileForArg

applicationCommandLineCreateFileForArg Source #

Arguments

:: (HasCallStack, MonadIO m, IsApplicationCommandLine a) |
=> a | `cmdline`: a `ApplicationCommandLine`
-> [Char] | `arg`: an argument from `cmdline`
-> m File | Returns: a new `File`

Creates a `File` corresponding to a filename that was given as part of the invocation of `cmdline`.

This differs from `fileNewForCommandlineArg` in that it resolves relative pathnames using the current working directory of the invoking process rather than the local process.

Since: 2.36

## getArguments

applicationCommandLineGetArguments Source #

Arguments

:: (HasCallStack, MonadIO m, IsApplicationCommandLine a) |
=> a | `cmdline`: a `ApplicationCommandLine`
-> m [[Char]] | Returns: the string array containing the arguments (the argv)

Gets the list of arguments that was passed on the command line.

The strings in the array may contain non-UTF-8 data on UNIX (such as filenames or arguments given in the system locale) but are always in UTF-8 on Windows.

If you wish to use the return value with `OptionContext`, you must use `optionContextParseStrv`.

The return value is `Nothing`-terminated and should be freed using `strfreev`.

Since: 2.28

## getCwd

applicationCommandLineGetCwd Source #

Arguments

:: (HasCallStack, MonadIO m, IsApplicationCommandLine a) |
=> a | `cmdline`: a `ApplicationCommandLine`
-> m (Maybe [Char]) | Returns: the current directory, or `Nothing`

Gets the working directory of the command line invocation. The string may contain non-utf8 data.

It is possible that the remote application did not send a working directory, so this may be `Nothing`.

The return value should not be modified or freed and is valid for as long as `cmdline` exists.

Since: 2.28

## getEnviron

applicationCommandLineGetEnviron Source #

Arguments

:: (HasCallStack, MonadIO m, IsApplicationCommandLine a) |
=> a | `cmdline`: a `ApplicationCommandLine`
-> m [[Char]] | Returns: the environment strings, or `Nothing` if they were not sent

Gets the contents of the 'environ' variable of the command line invocation, as would be returned by `getEnviron`, ie as a `Nothing`-terminated list of strings in the form 'NAME=VALUE'. The strings may contain non-utf8 data.

The remote application usually does not send an environment. Use `ApplicationFlagsSendEnvironment` to affect that. Even with this flag set it is possible that the environment is still not available (due to invocation messages from other applications).

The return value should not be modified or freed and is valid for as long as `cmdline` exists.

See `applicationCommandLineGetenv` if you are only interested in the value of a single environment variable.

Since: 2.28

## getExitStatus

applicationCommandLineGetExitStatus Source #

Arguments

:: (HasCallStack, MonadIO m, IsApplicationCommandLine a) |
=> a | `cmdline`: a `ApplicationCommandLine`
-> m Int32 | Returns: the exit status

Gets the exit status of `cmdline`. See `applicationCommandLineSetExitStatus` for more information.

Since: 2.28

## getIsRemote

applicationCommandLineGetIsRemote Source #

Arguments

:: (HasCallStack, MonadIO m, IsApplicationCommandLine a) |
=> a | `cmdline`: a `ApplicationCommandLine`
-> m Bool | Returns: `True` if the invocation was remote

Determines if `cmdline` represents a remote invocation.

Since: 2.28

## getOptionsDict

applicationCommandLineGetOptionsDict Source #

Arguments

:: (HasCallStack, MonadIO m, IsApplicationCommandLine a) |
=> a | `cmdline`: a `ApplicationCommandLine`
-> m VariantDict | Returns: a `VariantDict` with the options

Gets the options there were passed to `g_application_command_line()`.

If you did not override `local_command_line()` then these are the same options that were parsed according to the `GOptionEntrys` added to the application with `applicationAddMainOptionEntries` and possibly modified from your GApplication[handleLocalOptions](#g:signal:handleLocalOptions) handler.

If no options were sent then an empty dictionary is returned so that you don't need to check for `Nothing`.

Since: 2.40

## getPlatformData

applicationCommandLineGetPlatformData Source #

Arguments

:: (HasCallStack, MonadIO m, IsApplicationCommandLine a) |
=> a | `cmdline`: `ApplicationCommandLine`
-> m (Maybe GVariant) | Returns: the platform data, or `Nothing`

Gets the platform data associated with the invocation of `cmdline`.

This is a `GVariant` dictionary containing information about the context in which the invocation occurred. It typically contains information like the current working directory and the startup notification ID.

For local invocation, it will be `Nothing`.

Since: 2.28

## getStdin

applicationCommandLineGetStdin Source #

Arguments

:: (HasCallStack, MonadIO m, IsApplicationCommandLine a) |
=> a | `cmdline`: a `ApplicationCommandLine`
-> m InputStream | Returns: a `InputStream` for stdin

Gets the stdin of the invoking process.

The `InputStream` can be used to read data passed to the standard input of the invoking process. This doesn't work on all platforms. Presently, it is only available on UNIX when using a DBus daemon capable of passing file descriptors. If stdin is not available then `Nothing` will be returned. In the future, support may be expanded to other platforms.

You must only call this function once per commandline invocation.

Since: 2.34

## getenv

applicationCommandLineGetenv Source #

Arguments

:: (HasCallStack, MonadIO m, IsApplicationCommandLine a) |
=> a | `cmdline`: a `ApplicationCommandLine`
-> [Char] | `name`: the environment variable to get
-> m Text | Returns: the value of the variable, or `Nothing` if unset or unsent

Gets the value of a particular environment variable of the command line invocation, as would be returned by `getenv`. The strings may contain non-utf8 data.

The remote application usually does not send an environment. Use `ApplicationFlagsSendEnvironment` to affect that. Even with this flag set it is possible that the environment is still not available (due to invocation messages from other applications).

The return value should not be modified or freed and is valid for as long as `cmdline` exists.

Since: 2.28

## setExitStatus

applicationCommandLineSetExitStatus Source #

Arguments

:: (HasCallStack, MonadIO m, IsApplicationCommandLine a) |
=> a | `cmdline`: a `ApplicationCommandLine`
-> Int32 | `exitStatus`: the exit status
-> m () |

Sets the exit status that will be used when the invoking process exits.

The return value of the commandLine signal is passed to this function when the handler returns. This is the usual way of setting the exit status.

In the event that you want the remote invocation to continue running and want to decide on the exit status in the future, you can use this call. For the case of a remote invocation, the remote process will typically exit when the last reference is dropped on `cmdline`. The exit status of the remote process will be equal to the last value that was set with this function.

In the case that the commandline invocation is local, the situation is slightly more complicated. If the commandline invocation results in the mainloop running (ie: because the use-count of the application increased to a non-zero value) then the application is considered to have been 'successful' in a certain sense, and the exit status is always zero. If the application use count is zero, though, the exit status of the local `ApplicationCommandLine` is used.

Since: 2.28

# Properties

## arguments

No description available in the introspection data.

constructApplicationCommandLineArguments :: (IsApplicationCommandLine o, MonadIO m) => GVariant -> m (GValueConstruct o) Source #

Construct a `GValueConstruct` with valid value for the “`arguments`” property. This is rarely needed directly, but it is used by `new`.

## isRemote

No description available in the introspection data.

getApplicationCommandLineIsRemote :: (MonadIO m, IsApplicationCommandLine o) => o -> m Bool Source #

Get the value of the “`is-remote`” property. When overloading is enabled, this is equivalent to

    get applicationCommandLine #isRemote

## options

No description available in the introspection data.

constructApplicationCommandLineOptions :: (IsApplicationCommandLine o, MonadIO m) => GVariant -> m (GValueConstruct o) Source #

Construct a `GValueConstruct` with valid value for the “`options`” property. This is rarely needed directly, but it is used by `new`.

## platformData

No description available in the introspection data.

constructApplicationCommandLinePlatformData :: (IsApplicationCommandLine o, MonadIO m) => GVariant -> m (GValueConstruct o) Source #

Construct a `GValueConstruct` with valid value for the “`platform-data`” property. This is rarely needed directly, but it is used by `new`.